import { InternalFeatureRepository } from './internal_feature_repository';
import { AnalyticsCollector } from './analytics';
import { FeatureStateValueInterceptor } from './interceptors';
import { ClientContext } from './client_context';
import { EdgeServiceProvider, FeatureHubConfig } from './feature_hub_config';
import { Readyness, ReadynessListener } from './featurehub_repository';
export declare class EdgeFeatureHubConfig implements FeatureHubConfig {
    private _host;
    private _apiKey;
    private _apiKeys;
    private _clientEval;
    private _url;
    private _repository;
    private _edgeService;
    private _edgeServices;
    static defaultEdgeServiceSupplier: EdgeServiceProvider;
    constructor(host: string, apiKey: string);
    addReadynessListener(listener: ReadynessListener): void;
    addAnalyticCollector(collector: AnalyticsCollector): void;
    addValueInterceptor(interceptor: FeatureStateValueInterceptor): void;
    get readyness(): Readyness;
    apiKey(apiKey: string): FeatureHubConfig;
    clientEvaluated(): boolean;
    getApiKeys(): string[];
    getHost(): string;
    newContext(repository?: InternalFeatureRepository, edgeService?: EdgeServiceProvider): ClientContext;
    private getOrCreateEdgeService;
    private createEdgeService;
    close(): void;
    init(): FeatureHubConfig;
    edgeServiceProvider(edgeServ?: EdgeServiceProvider): EdgeServiceProvider;
    repository(repository?: InternalFeatureRepository): InternalFeatureRepository;
    url(): string;
}
